;(function(){

	window._w.dealers = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.dealers.ti = _t[template];

			_w.dealers.initGrids();

			// Dealer grid
			if (null == App.API.taskContract('gridSystemDealer'))
			{
				App.API.getTask(
						'gridSystemDealer', 'Company', 'Company.Grid', null,
						{}, _w.dealers.loadDealerGrid, _w.taskContractError
						);
			}
			else
			{
				_w.dealers.loadDealerGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			$(".gridDealerFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnDealerSearch').click();
				}
			});
			
			_w.dealers.ti = _t[template];

			// Dealer grid
			$('#btnDealerAdd').click(function() {
				window.location.hash = '/systemuserview?id=0';
			});
            $('#btnDealerClearSearch').click(_w.dealers.clearDealerGridContext);
            $('#btnDealerSearch').click(_w.dealers.searchDealerGrid);

		},

		exportDealerGrid : function()
		{
			App.API.execTask(
					'gridSystemDealer', {}, {'ExportToExcel': true},
					_w.dealers._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		initGrids : function()
		{

			_w.dealers.ti.hydrate({
				// Dealer grid
				'gridDealerTitle': 'Manage dealerships',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'GridExport',
							id: 'exportAuctionGrid',
							handler: _w.dealers.exportDealerGrid
						}
					}
				},
				'gridDealerColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Group: {
							id: 'gridDealerColumn_Group',
							title: 'GROUP',
							orderAsc: {
								id: 'gridDealerOrder_GroupAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'grp.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_GroupDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'grp.name', 'DESC')
							}
						},
						Division: {
							id: 'gridDealerColumn_Division',
							title: 'DIVISION',
							orderAsc: {
								id: 'gridDealerOrder_DivisionAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'division.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_DivisionDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'division.name', 'DESC')
							}
						},
						Company: {
							id: 'gridDealerColumn_Company',
							title: 'DEALERSHIP',
							orderAsc: {
								id: 'gridDealerOrder_CompanyAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'company.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_CompanyDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'company.name', 'DESC')
							}
						},
						Name: {
							id: 'gridDealerColumn_Name',
							title: 'CONTACT NAME',
							orderAsc: {
								id: 'gridDealerOrder_NameAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'contact.firstName', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_NameDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'contact.firstName', 'DESC')
							}
						},
						Surname: {
							id: 'gridDealerColumn_Surname',
							title: 'CONTACT SURNAME',
							orderAsc: {
								id: 'gridDealerOrder_SurnameAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'contact.familyName', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_SurnameDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'contact.familyName', 'DESC')
							}
						},
						Email: {
							id: 'gridDealerColumn_Email',
							title: 'CONTACT EMAIL',
							orderAsc: {
								id: 'gridDealerOrder_EmailAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'contact.email', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_EmailDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'contact.email', 'DESC')
							}
						},
						Status: {
							id: 'gridDealerColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridDealerOrder_StatusAsc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'company.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridDealerOrder_StatusDesc',
								bind: $.proxy(_w.dealers.orderDealerGrid, this, 'company.jobState', 'DESC')
							}
						}
					}
				},
				'gridDealerColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Group : {
							id: 'gridDealerFilter_Group',
							context: 'gridDealerFilter'
						},
						Division : {
							id: 'gridDealerFilter_Division',
							context: 'gridDealerFilter'
						},
						Company : {
							id: 'gridDealerFilter_Company',
							context: 'gridDealerFilter'
						},
						Name: {
							id: 'gridDealerFilter_Name',
							context: 'gridDealerFilter'
						},
						Surname: {
							id: 'gridDealerFilter_Surname',
							context: 'gridDealerFilter'
						},
						Email: {
							id: 'gridDealerFilter_Email',
							context: 'gridDealerFilter'
						},
						Status: {
							id: 'gridDealerFilter_Status',
							context: 'gridDealerFilter'
						}
					}
				},
				'gridDealerRowRepeater': {},
				'gridDealerPager': {}
			});

		},

		loadDealerGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemDealer', data, options,
					_w.dealers._onDealerGridDataReceived, _w.taskExecError
					);
		},

		pageDealerGrid : function( page )
		{
			_w.dealers.loadDealerGrid( {}, {"Grid":{"Page":page}} );
		},

		clearDealerGridContext : function()
		{
			$('.gridDealerContext').val('');
			$('.gridDealerFilter').val('');
			_w.dealers.searchDealerGrid();
		},

		searchDealerGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Group', 'grp.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Division', 'division.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Company', 'company.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Name', 'contact.firstName');
			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Surname', 'contact.familyName');
			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Email', 'contact.email');
			filter = _w.filterIfnotEmpty(filter, 'gridDealerFilter_Status', 'company.jobState');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.dealers.loadDealerGrid( null, request, {} );
		},

		_onDealerGridDataReceived : function( response )
		{
			_w.dealers.ti.hydrateParam('gridDealerRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'group.name'         : 'gridDealerFilter_Group',
				'groupDivision.name' : 'gridDealerFilter_Division',
				'company.name'       : 'gridDealerFilter_Company',
				'profile.firstName'  : 'gridDealerFilter_Name',
				'profile.familyName' : 'gridDealerFilter_Surname',
				'profile.email'      : 'gridDealerFilter_Email',
				'company.jobState'     : 'gridDealerFilter_Status'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'systemdealerview',
					prepend: {},
					style: {},
					items: {
						'id'         : row.id,
						'Group'      : row.group ? row.group.name : '',
						'Division'   : row.groupDivision ? row.groupDivision.name : '',
						'Company'    : row.name,
						'Name'       : row.contact ? row.contact.firstName : '',
						'Surname'    : row.contact ? row.contact.familyName : '',
						'Email'      : row.contact ? row.contact.email : '',
						'Status'     : row.jobState
				}
				});
			}
			_w.dealers.ti.hydrateParam('gridDealerRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.dealers.pageDealerGrid;
			_w.dealers.ti.hydrateParam('gridDealerPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderDealerGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.dealers.loadDealerGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
			win.document.write(response);
		}

	};

})();