;(function(){

	window._w.groups = {

		ti : null,
		itemId : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.groups.ti = _t[template];
			_w.groups.initGrid();

			App.DataStore.setData('pricingTypes', [
   		           {"value":"Incremental", "label":"Incremental"},
   		           {"value":"Fixed", "label":"Fixed"}
   		           ]);
			App.DataStore.setData('priceGuideYesNo', [
                  {"value":"0", "label":"No"},
                  {"value":"1", "label":"Yes"}
                  ]);

			// Group grid
			if (null == App.API.taskContract('gridGroup'))
			{
				App.API.getTask(
						'gridGroup', 'Company', 'Group.List', null,
						{}, _w.groups.loadGroupGrid, _w.taskContractError
						);
			}
			else
			{
				_w.groups.loadGroupGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addGroup'))
			{
				App.API.getTask(
						'addGroup', 'Company', 'Group.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.groups.ti.hydrateParam('name', {
				type  : 'input',
				id    : 'name',
				title : 'Name',
				value : ''
			});
			_w.groups.ti.hydrateParam('pricingType', {
				type  : 'select',
				id    : 'pricingType',
				title : 'Pricing Type',
				value : '',
				dataStoreId : 'pricingTypes'
			});
			_w.groups.ti.hydrateParam('fixedPricing', {
				type  : 'input',
				id    : 'fixedPricing',
				title : 'Fixed Pricing',
				value : ''
			});
			_w.groups.ti.hydrateParam('priceGuide', {
				type  : 'select',
				id    : 'priceGuide',
				title : 'Price Guide',
				value : '',
				dataStoreId : 'priceGuideYesNo'
			});
			_w.groups._setupValidation();
			$('#btnNew').click(function() {
				_w.groups.itemId = null;
				$('#name').val('');
				$('#pricingType').selectpicker('val', '');
				$('#fixedPricing').val('0');
				$('#priceGuide').selectpicker('val', '');
				$('label.error').remove();
				$('#btnSave').html(' Add ');
			});
			$('#btnNew').prop('disabled', false);
		},

		initGrid : function()
		{

			_w.groups.ti.hydrate({
				// Group grid
				'gridGroupTitle': 'Manage groups',
				'gridGroupColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						name: {
							id: 'gridGroupColumn_name',
							title: 'NAME'
						},
						pricingType: {
							id: 'gridGroupColumn_pricingType',
							title: 'PRICING TYPE'
						},
						fixedPricing: {
							id: 'gridGroupColumn_fixedPricing',
							title: 'FIXED PRICE'
						},
						priceGuide: {
							id: 'gridGroupColumn_priceGuide',
							title: 'PRICE GUIDE'
						}
					}
				},
				'gridGroupRowRepeater': {}
			});

		},

		loadGroupGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridGroup', data, options,
					_w.groups._onGroupGridDataReceived, _w.taskExecError
					);
		},

		_onGroupGridDataReceived : function( response )
		{
			_w.groups.ti.hydrateParam('gridGroupRowRepeater', {});
			var gridData = [];
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				gridData.push({
					prepend: {
						Amount  : 'R '
					},
					rowId : row.id,
					onClick : function(meta) {
						_w.groups.itemId = meta.rowId;
						$('#name').val(meta.items.name);
						$('#pricingType').selectpicker('val', meta.items.pricingType);
						$('#fixedPricing').val(meta.items.fixedPricing);
						$('#priceGuide').selectpicker('val', 'Yes' == meta.items.priceGuide ? '1' : '0');
						$('#btnSave').html(' Update ');
					},
					items: {
						'id' 			: row.id,
						'name' 			: row.name,
						'pricingType' 	: row.pricingType,
						'fixedPricing' 	: row.fixedPricing ? row.fixedPricing : '0',
						'priceGuide' 	: row.priceGuide ? 'Yes' : 'No'
					}
				});
			}
			_w.groups.ti.hydrateParam('gridGroupRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		_setupValidation : function ()
		{
			$('#frmGroupView').validate({
				"rules": {
					name 			: "required",
					pricingType 	: "required",
					fixedPricing 	: {digits: true, required: true},
					priceGuide 		: "required"
				},
				messages: {
					name 		: "This field is required.",
					pricingType : "This field is required.",
					priceGuide 	: "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var data = {
							Group: {
								name: $('#name').val(),
								pricingType: $('#pricingType').val(),
								fixedPricing: $('#fixedPricing').val(),
								priceGuide: $('#priceGuide').val()
							}
					};
					if (null == _w.groups.itemId)
					{
						App.API.execTask(
								'addGroup', data, {},
								function() {
									$('#name').val('');
									$('#pricingType').selectpicker('val', '');
									$('#fixedPricing').val('0');
									$('#priceGuide').selectpicker('val', '');
									$('label.error').remove();
									_w.groups.loadGroupGrid( null, {}, {} );
									$('#btnSave').prop('disabled', false);
									$('#btnSave').html(' Add ');
								}, _w.taskExecError
							);
					}
					else
					{
						App.API.getTask(
								'updateGroup' + _w.groups.itemId, 'Company', 'Group.Update', null,
								{id: _w.groups.itemId}, function () {
									App.API.execTask(
											'updateGroup' + _w.groups.itemId, data, {},
											function() {
												$('#name').val('');
												$('#pricingType').selectpicker('val', '');
												$('#fixedPricing').val('0');
												$('#priceGuide').selectpicker('val', '');
												$('label.error').remove();
												_w.groups.loadGroupGrid( null, {}, {} );
												$('#btnSave').prop('disabled', false);
												$('#btnSave').html(' Add ');
											}, _w.taskExecError
										);
								}, _w.taskContractError
								);
					}
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();