;(function(){

	window._w.systemdisputes = {

		itemId        : null,
		itemData      : null,
		formMeta      : null,
		offerId       : null,
		offerData     : null,
		formOfferMeta : null,
		ti            : null,
		limited       : false,
		newItem       : false,

		onTemplateReady : function( template, event, eventData )
		{
			_w.systemdisputes.ti = _t[template];

			_w.systemdisputes.initGrids();

			// Dispute grid
			if (null == App.API.taskContract('gridSystemDispute'))
			{
				App.API.getTask(
						'gridSystemDispute', 'Dispute', 'Dispute.AdminGrid', null,
						{}, _w.systemdisputes.loadDisputeGrid, _w.taskContractError
						);
			}
			else
			{
				_w.systemdisputes.loadDisputeGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.systemdisputes.ti = _t[template];

			// Dispute grid
            $('#btnDisputeClearSearch').click(_w.systemdisputes.clearDisputeGridContext);
            $('#btnDisputeSearch').click(_w.systemdisputes.searchDisputeGrid);

		},

		initGrids : function()
		{

			_w.systemdisputes.ti.hydrate({
				// Dispute grid
				'gridDisputeTitle': 'Manage system disputes',
				'gridDisputeColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Plaintive: {
							id: 'gridDisputeColumn_Plaintive',
							title: 'PLAINTIFF',
							orderAsc: {
								id: 'gridDisputeOrder_PlaintiveAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'fromCompany.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_PlaintiveDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'fromCompany.name', 'DESC')
							}
						},
						Defendant: {
							id: 'gridDisputeColumn_Defendant',
							title: 'DEFENDANT',
							orderAsc: {
								id: 'gridDisputeOrder_DefendantAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'againstCompany.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_DefendantDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'againstCompany.name', 'DESC')
							}
						},
						Make: {
							id: 'gridDisputeColumn_Make',
							title: 'VEHICLE MAKE',
							orderAsc: {
								id: 'gridDisputeOrder_MakeAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'make.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_MakeDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'make.name', 'DESC')
							}
						},
						Model: {
							id: 'gridDisputeColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridDisputeOrder_ModelAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'model.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_ModelDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'model.name', 'DESC')
							}
						},
						Type: {
							id: 'gridDisputeColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridDisputeOrder_TypeAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'type.name', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_TypeDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'type.name', 'DESC')
							}
						},
						Reg: {
							id: 'gridDisputeColumn_Reg',
							title: 'REGISTRATION',
							orderAsc: {
								id: 'gridDisputeOrder_RegAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'stock.registrationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_RegDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'stock.registrationNumber', 'DESC')
							}
						},
						Status: {
							id: 'gridDisputeColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridDisputeOrder_StatusAsc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'dispute.jobState', 'ASC')
							},
							orderDesc: {
								id: 'gridDisputeOrder_StatusDesc',
								bind: $.proxy(_w.systemdisputes.orderDisputeGrid, this, 'dispute.jobState', 'DESC')
							}
						}
					}
				},
				'gridDisputeColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Plaintive: {
							id: 'gridDisputeFilter_Plaintive',
							context: 'gridDisputeFilter'
						},
						Defendant: {
							id: 'gridDisputeFilter_Defendant',
							context: 'gridDisputeFilter'
						},
						Make: {
							id: 'gridDisputeFilter_Make',
							context: 'gridDisputeFilter'
						},
						Model: {
							id: 'gridDisputeFilter_Model',
							context: 'gridDisputeFilter'
						},
						Type: {
							id: 'gridDisputeFilter_Type',
							context: 'gridDisputeFilter'
						},
						Reg: {
							id: 'gridDisputeFilter_Reg',
							context: 'gridDisputeFilter'
						},
						Status: {
							id: 'gridDisputeFilter_Status',
							context: 'gridDisputeFilter'
						}
					}
				},
				'gridDisputeRowRepeater': {},
				'gridDisputePager': {}
			});

		},

		loadDisputeGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemDispute', data, options,
					_w.systemdisputes._onDisputeGridDataReceived, _w.taskExecError
					);
		},

		pageDisputeGrid : function( page )
		{
			_w.systemdisputes.loadDisputeGrid( {}, {"Grid":{"Page":page}} );
		},

		clearDisputeGridContext : function()
		{
			$('.gridDisputeContext').val('');
			$('.gridDisputeFilter').val('');
			_w.systemdisputes.searchDisputeGrid();
		},

		searchDisputeGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Plaintive', 'fromCompany.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Defendant', 'againstCompany.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Make', 'make.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Model', 'model.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Type', 'type.name');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Reg', 'stock.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridDisputeFilter_Status', 'dispute.jobState');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.systemdisputes.loadDisputeGrid( null, request, {} );
		},

		_onDisputeGridDataReceived : function( response )
		{
			_w.systemdisputes.ti.hydrateParam('gridDisputeRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'fromCompany.name'                   : 'gridDisputeFilter_Plaintive',
				'againstCompany.name'                : 'gridDisputeFilter_Defendant',
				'auction.stock.type.model.make.name' : 'gridDisputeFilter_Make',
				'auction.stock.type.model.name'      : 'gridDisputeFilter_Model',
				'auction.stock.type..name'           : 'gridDisputeFilter_Type',
				'auction.stock.registrationNumber'   : 'gridDisputeFilter_Reg',
				'jobState'                           : 'gridDisputeFilter_Status'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'systemdisputeview',
					prepend: {},
					style: {},
					items: {
						'id'        : row.id,
						'Plaintive' : row.fromCompany.name,
						'Defendant' : row.againstCompany.name,
						'Make'      : row.auction.stock.type.model.make.name,
						'Model'     : row.auction.stock.type.model.name,
						'Type'      : row.auction.stock.type.name,
						'Reg'       : row.auction.stock.registrationNumber,
						'Status'    : row.jobState
				}
				});
			}
			_w.systemdisputes.ti.hydrateParam('gridDisputeRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'disputePager';
			response.Data.Meta.bind = _w.systemdisputes.pageDisputeGrid;
			_w.systemdisputes.ti.hydrateParam('gridDisputePager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderDisputeGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.systemdisputes.loadDisputeGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();