;(function(){

	window._w.systemdisputeview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.systemdisputeview.ti = _t[template];
			_w.systemdisputeview.setDisputeViewFormMeta();
			_w.systemdisputeview.ti.hydrate(_w.systemdisputeview.formMeta);

			// Retrieve initial view data.
			_w.systemdisputeview.itemId = App.Util.getUrlParam('id');
			App.API.getTask(
				'viewDispute:' + _w.systemdisputeview.itemId, 'Dispute', 'Dispute.View', _w.systemdisputeview.itemId,
				{'id':_w.systemdisputeview.itemId}, $.proxy( _w.systemdisputeview._onDisputeViewDataReceived, this ), _w.taskContractError
			);
			App.API.getTask(
				'updateDispute:' + _w.systemdisputeview.itemId, 'Dispute', 'Dispute.Update', _w.systemdisputeview.itemId,
				{'id':_w.systemdisputeview.itemId}, function() {}, _w.taskContractError
			);
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.systemdisputeview.ti = _t[template];
			$('#btnNew').click(_w.systemdisputeview._routeNew);
			$('#btnProgress').click(_w.systemdisputeview._routeInProgress);
			$('#btnResolve').click(_w.systemdisputeview._routeResolve);
		},

		_routeNew : function()
		{
			if ('' == $('#complaint').val())
			{
				alert('Please specify the complaint.');
				return;
			}
			$('#btnUpdate').prop('disabled', true);
			var data = _w.systemdisputeview._prepDisputeUpdateData();
			App.API.execTask(
					'updateDispute:' + _w.systemdisputeview.itemId, data, {},
					function() {
						App.API.directRoute(
								'routeDisputeInProgress:' + _w.systemdisputeview.itemId, 'Dispute', 'Workflow.MoveToNew',
								_w.systemdisputeview.itemId, {}, _w.systemdisputeview._onDisputeUpdated, _w.taskExecError
							);
					}, _w.taskExecError
				);
		},

		_routeInProgress : function()
		{
			if ('' == $('#complaint').val())
			{
				alert('Please specify the complaint.');
				return;
			}
			$('#btnUpdate').prop('disabled', true);
			var data = _w.systemdisputeview._prepDisputeUpdateData();
			App.API.execTask(
					'updateDispute:' + _w.systemdisputeview.itemId, data, {},
					function() {
						App.API.directRoute(
								'routeDisputeInProgress:' + _w.systemdisputeview.itemId, 'Dispute', 'Workflow.MoveToInProgress',
								_w.systemdisputeview.itemId, {}, _w.systemdisputeview._onDisputeUpdated, _w.taskExecError
							);
					}, _w.taskExecError
				);
		},

		_routeResolve: function()
		{
			if ('' == $('#complaint').val())
			{
				alert('Please specify the complaint.');
				return;
			}
			$('#btnUpdate').prop('disabled', true);
			var data = _w.systemdisputeview._prepDisputeUpdateData();
			App.API.execTask(
					'updateDispute:' + _w.systemdisputeview.itemId, data, {},
					function() {
						App.API.directRoute(
								'routeDisputeResolve:' + _w.systemdisputeview.itemId, 'Dispute', 'Workflow.Resolve',
								_w.systemdisputeview.itemId, {}, _w.systemdisputeview._onDisputeUpdated, _w.taskExecError
							);
					}, _w.taskExecError
				);
		},

		setDisputeViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.systemdisputeview.formMeta = {
					'jobState' : {
						title       : 'Status',
						value       : data.jobState
					},
					'created' : {
						title       : 'Created',
						value       : data.created ? ((data.created).split(' '))[0] : ''
					},
					'vehicle' : {
						title       : 'Vehicle',
						value       : data.auction ? data.auction.stock.type.model.make.name
											+ ', ' + data.auction.stock.type.model.name
											+ ', ' + data.auction.stock.type.name
											+ ' (' + data.auction.stock.vehicleYear.name + ')'
										: ''
					},
					'plaintive' : {
						title       : 'Plaintiff',
						value       : data.fromCompany ? data.fromCompany.name : ''
					},
					'plaintiveContact' : {
						title       : 'Contact person',
						value       : data.fromCompany
										? data.fromCompany.contact.firstName
												+ ' ' + data.fromCompany.contact.familyName
										: ''
					},
					'plaintiveOffice' : {
						title       : 'Office',
						value       : data.fromCompany ? data.fromCompany.contact.office : ''
					},
					'plaintiveMobile' : {
						title       : 'Mobile',
						value       : data.fromCompany ? data.fromCompany.contact.mobile : ''
					},
					'plaintiveEmail' : {
						title       : 'Email',
						value       : data.fromCompany ? data.fromCompany.contact.email : ''
					},
					'defendant' : {
						title       : 'Plaintiff',
						value       : data.againstCompany ? data.againstCompany.name : ''
					},
					'defendantContact' : {
						title       : 'Contact person',
						value       : data.againstCompany
						? data.againstCompany.contact.firstName
								+ ' ' + data.againstCompany.contact.familyName
								: ''
					},
					'defendantOffice' : {
						title       : 'Office',
						value       : data.againstCompany ? data.againstCompany.contact.office : ''
					},
					'defendantMobile' : {
						title       : 'Mobile',
						value       : data.againstCompany ? data.againstCompany.contact.mobile : ''
					},
					'defendantEmail' : {
						title       : 'Email',
						value       : data.againstCompany ? data.againstCompany.contact.email : ''
					},
					'complaint' : {
						type        : 'textarea-styled',
						id          : 'complaint',
						title       : 'Complaint',
						value       : data.complaint,
						areaStyle   : 'span12',
						style       : 'span10'
					},
					'resolution' : {
						type        : 'textarea-styled',
						id          : 'resolution',
						title       : 'Resolution',
						value       : data.resolution,
						areaStyle   : 'span12',
						style       : 'span10'
					}
			};
		},

		_onDisputeViewDataReceived : function( response )
		{
			console.log(response.Data);
			if (response.Data.company)
			{
				App.DataStore.loadSelectListData('managers', true, 'Dispute', 'Profile.ManagerList', null, {
					Filter: {company: response.Data.company.id}
				});
			}
			else
			{
				App.DataStore.setData('managers', []);
			}
			_w.systemdisputeview.itemId = response.Data.id;
			_w.systemdisputeview.itemData = response.Data;
			_w.systemdisputeview.setDisputeViewFormMeta(response.Data);
			_w.systemdisputeview.ti.hydrate(_w.systemdisputeview.formMeta);
			switch (response.Data.jobState)
			{
			case 'Pending Payment':
				$('#btnNew').show();
				$('#btnProgress').show();
				$('#btnResolve').show();
				break;
			case 'New':
				$('#btnProgress').show();
				$('#btnResolve').show();
				break;
			case 'In Progress':
				$('#btnResolve').show();
				break;
			}
			_w.systemdisputeview._setupValidation();
		},

		_setupValidation : function ()
		{
			$('#frmDisputeView').validate({
				submitHandler: function( form ) {
					if ('' == $('#complaint').val())
					{
						alert('Please specify the complaint.');
						return;
					}
					$('#btnUpdate').prop('disabled', true);
					var data = _w.systemdisputeview._prepDisputeUpdateData();
					App.API.execTask(
							'updateDispute:' + _w.systemdisputeview.itemId, data, {},
							_w.systemdisputeview._onDisputeUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepDisputeUpdateData : function()
		{
			var data = {
					Dispute: {
						'complaint'  : $('#complaint').val(),
						'resolution' : $('#resolution').val()
					}
				};
			return data;
		},

		_onDisputeUpdated : function( response )
		{
			window.location.hash = '/systemdisputes';
		}

	};

})();