;(function(){

	window._w.userpermissions = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.userpermissions.ti = _t[template];
			App.DataStore.setData('stockstatuses',
					[
					 {"value":"Permissions", "label":"Permissions"},
					 {"value":"Price Guide", "label":"Price Guide"},
					 {"value":"Archived", "label":"Archived"}
					 ]
			);
			_w.userpermissions.ti.hydrate({
				'gridTitle': 'Permissions Control',
				'gridTitleSubtext': 'Please use the filters below to narrow down the view',
				'gridColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Title: {
							id: 'gridPermissionsColumn_Title',
							title: 'TITLE',
							orderAsc: {
								id: 'gridPermissionsOrder_TitleAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.name', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_TitleDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.name', 'DESC')
							}
						},
						Admin: {
							id: 'gridPermissionsColumn_Admin',
							title: 'ADMIN ACCESS',
							orderAsc: {
								id: 'gridPermissionsOrder_AdminAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.accessAdminModule', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_AdminDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.accessAdminModule', 'DESC')
							}
						},
						Portal: {
							id: 'gridPermissionsColumn_Portal',
							title: 'PORTAL ACCESS',
							orderAsc: {
								id: 'gridPermissionsOrder_PortalAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.accessPortalModule', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_PortalDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.accessPortalModule', 'DESC')
							}
						},
						Stock: {
							id: 'gridPermissionsColumn_Stock',
							title: 'STOCK ACCESS',
							orderAsc: {
								id: 'gridPermissionsOrder_StockAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.stockPage', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_StockDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.stockPage', 'DESC')
							}
						},
						Valuation: {
							id: 'gridPermissionsColumn_Valuation',
							title: 'VALUATION ACCESS',
							orderAsc: {
								id: 'gridPermissionsOrder_ValuationAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.valuationPage', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_ValuationDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.valuationPage', 'DESC')
							}
						},
						Settings: {
							id: 'gridPermissionsColumn_Settings',
							title: 'SETTINGS ACCESS',
							orderAsc: {
								id: 'gridPermissionsOrder_SettingsAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.settingsPage', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_SettingsDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.settingsPage', 'DESC')
							}
						},
						PriceGuide: {
							id: 'gridPermissionsColumn_PriceGuide',
							title: 'PRICE GUIDE ACCESS',
							orderAsc: {
								id: 'gridPermissionsOrder_PriceGuideAsc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.pgPage', 'ASC')
							},
							orderDesc: {
								id: 'gridPermissionsOrder_PriceGuideDesc',
								bind: $.proxy(_w.userpermissions.orderPermissionsGrid, this, 'permissions.pgPage', 'DESC')
							}
						}
					}
				},
				'gridColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						Title: {
							id: 'gridPermissionsFilter_Title',
							context: 'gridPermissionsFilter'
						},
						Admin: null,
						Portal: null,
						Stock: null,
						Valuation: null,
						Settings: null,
						PriceGuide: null
					}
				},
				'gridRowRepeater': {},
				'gridPager': {}
			});

			// Retrieve initial grid data.
			if (null == App.API.taskContract('gridPermissions'))
			{
				App.API.getTask(
						'gridPermissions', 'User', 'Permissions.Grid', null,
						{}, _w.userpermissions.loadPermissionsGrid, _w.taskContractError
						);
			}
			else
			{
				_w.userpermissions.loadPermissionsGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function()
		{
			$(".gridPermissionsFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnSearch').click();
				}
			});
			
			$('#btnClearSearch').click(_w.userpermissions.clearPermissionsGridContext);
            $('#btnSearch').click(_w.userpermissions.searchPermissionsGrid);
		},

		pagePermissionsGrid : function( page )
		{
			_w.userpermissions.loadPermissionsGrid( {}, {"Grid":{"Page":page}} );
		},

		loadPermissionsGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridPermissions', data, options,
					_w.userpermissions._onPermissionsGridDataReceived, _w.taskExecError
					);
		},

		_onPermissionsGridDataReceived : function( response )
		{
			_w.userpermissions.ti.hydrateParam('gridRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'permissions.name': 'gridPermissionsContext_Title'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'viewuserpermissions',
					prepend: {},
					style: {},
					items: {
						'id'         : row.id,
						'Title'      : row.name,
						'Admin'      : row.accessAdminModule ? 'Yes' : 'No',
						'Portal'     : row.accessPortalModule ? 'Yes' : 'No',
						'Stock'      : row.stockPage ? 'Yes' : 'No',
						'Valuation'  : row.valuationPage ? 'Yes' : 'No',
						'Settings'   : row.settingsPage ? 'Yes' : 'No',
						'PriceGuide' : row.pgPage ? 'Yes' : 'No'
					}
				});
			}
			_w.userpermissions.ti.hydrateParam('gridRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'permissionsPager';
			response.Data.Meta.bind = _w.userpermissions.pagePermissionsGrid;
			_w.userpermissions.ti.hydrateParam('gridPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		exportPermissionsGrid : function()
		{
			App.API.execTask(
					'gridPermissions', {}, {'ExportToExcel': true},
					_w.userpermissions._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
            win.document.write(response);
		},

		clearPermissionsGridContext : function()
		{
			$('.gridPermissionsContext').val('');
			$('.gridPermissionsFilter').val('');
			_w.userpermissions.searchPermissionsGrid();
		},

		searchPermissionsGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};
			filter = _w.filterIfnotEmpty(filter, 'gridPermissionsFilter_Title', 'permissions.name');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.userpermissions.loadPermissionsGrid( null, request, {} );
		},

		orderPermissionsGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.userpermissions.loadPermissionsGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		}

	};

})();