;(function(){

	window._w.xmlrpcclients = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.xmlrpcclients.ti = _t[template];

			_w.xmlrpcclients.initGrids();

			// XmlRpc grid
			if (null == App.API.taskContract('gridSystemXmlRpcClient'))
			{
				App.API.getTask(
						'gridSystemXmlRpcClient', 'Valuation', 'XmlRpc.Grid', null,
						{}, _w.xmlrpcclients.loadXmlRpcGrid, _w.taskContractError
						);
			}
			else
			{
				_w.xmlrpcclients.loadXmlRpcGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			$(".gridXmlRpcFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnXmlRpcSearch').click();
				}
			});

			_w.xmlrpcclients.ti = _t[template];

			// XmlRpc grid
			$('#btnXmlRpcAdd').click(function() {
				window.location.hash = '/xmlrpcclientview?id=0';
			});
            $('#btnXmlRpcClearSearch').click(_w.xmlrpcclients.clearXmlRpcGridContext);
            $('#btnXmlRpcSearch').click(_w.xmlrpcclients.searchXmlRpcGrid);

		},

		exportXmlRpcGrid : function()
		{
			App.API.execTask(
					'gridSystemXmlRpcClient', {}, {'ExportToExcel': true},
					_w.xmlrpcclients._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		initGrids : function()
		{

			_w.xmlrpcclients.ti.hydrate({
				// XmlRpc grid
				'gridXmlRpcTitle': 'Manage xml-rpc clients',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						/*Export: {
							preset: 'GridExport',
							id: 'exportAuctionGrid',
							handler: _w.xmlrpcclients.exportXmlRpcGrid
						}*/
					}
				},
				'gridXmlRpcColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						ClientName: {
							id: 'gridXmlRpcColumn_ClientName',
							title: 'CLIENT NAME',
							orderAsc: {
								id: 'gridXmlRpcOrder_ClientNameAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.clientName', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ClientNameDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.clientName', 'DESC')
							}
						},
						ClientApiId: {
							id: 'gridXmlRpcColumn_ClientApiId',
							title: 'API ID',
							orderAsc: {
								id: 'gridXmlRpcOrder_ClientApiIdAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.clientApiId', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ClientApiIdDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.clientApiId', 'DESC')
							}
						},
						CallbackUrl: {
							id: 'gridXmlRpcColumn_CallbackUrl',
							title: 'CALLBACK URL',
							orderAsc: {
								id: 'gridXmlRpcOrder_CallbackUrlAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.callbackUrl', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_CallbackUrlDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.callbackUrl', 'DESC')
							}
						},
						TriggerSentToSales: {
							id: 'gridXmlRpcColumn_TriggerSentToSales',
							title: 'SEND TO SALES',
							orderAsc: {
								id: 'gridXmlRpcOrder_TriggerSentToSalesAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.triggerSentToSales', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_TriggerSentToSalesDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.triggerSentToSales', 'DESC')
							}
						},
						Created: {
							id: 'gridXmlRpcColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridXmlRpcOrder_CreatedAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.created', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_CreatedDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.created', 'DESC')
							}
						},
						Archived: {
							id: 'gridXmlRpcColumn_Archived',
							title: 'ARCHIVED',
							orderAsc: {
								id: 'gridXmlRpcOrder_ArchivedAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.archived', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ArchivedDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpc.archived', 'DESC')
							}
						}
					}
				},
				'gridXmlRpcColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						ClientName : {
							id: 'gridXmlRpcFilter_ClientName',
							context: 'gridXmlRpcFilter'
						},
						ClientApiId : {
							id: 'gridXmlRpcFilter_ClientApiId',
							context: 'gridXmlRpcFilter'
						},
						CallbackUrl : {
							id: 'gridXmlRpcFilter_CallbackUrl',
							context: 'gridXmlRpcFilter'
						},
						TriggerSentToSales: {
							id: 'gridXmlRpcFilter_TriggerSentToSales',
							context: 'gridXmlRpcFilter'
						},
						Created: {
							id: 'gridXmlRpcFilter_Created',
							context: 'gridXmlRpcFilter'
						},
						Archived: {
							id: 'gridXmlRpcFilter_Archived',
							context: 'gridXmlRpcFilter'
						}
					}
				},
				'gridXmlRpcRowRepeater': {},
				'gridXmlRpcPager': {}
			});

		},

		loadXmlRpcGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemXmlRpcClient', data, options,
					_w.xmlrpcclients._onXmlRpcGridDataReceived, _w.taskExecError
					);
		},

		pageXmlRpcGrid : function( page )
		{
			_w.xmlrpcclients.loadXmlRpcGrid( {}, {"Grid":{"Page":page}} );
		},

		clearXmlRpcGridContext : function()
		{
			$('.gridXmlRpcContext').val('');
			$('.gridXmlRpcFilter').val('');
			_w.xmlrpcclients.searchXmlRpcGrid();
		},

		searchXmlRpcGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ClientName', 'xmlRpc.clientName');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ClientApiId', 'xmlRpc.clientApiId');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_CallbackUrl', 'xmlRpc.callbackUrl');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_TriggerSentToSales', 'xmlRpc.triggerSentToSales');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Created', 'xmlRpc.created');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Archived', 'xmlRpc.archived');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.xmlrpcclients.loadXmlRpcGrid( null, request, {} );
		},

		_onXmlRpcGridDataReceived : function( response )
		{
			_w.xmlrpcclients.ti.hydrateParam('gridXmlRpcRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'xmlRpc.clientName' 		: 'gridXmlRpcFilter_ClientName',
				'xmlRpc.clientApiId' 		: 'gridXmlRpcFilter_ClientApiId',
				'xmlRpc.callbackUrl' 		: 'gridXmlRpcFilter_CallbackUrl',
				'xmlRpc.triggerSentToSales' : 'gridXmlRpcFilter_TriggerSentToSales',
				'xmlRpc.created'			: 'gridXmlRpcFilter_Created',
				'xmlRpc.archived'			: 'gridXmlRpcFilter_Archived'
			});
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				gridData.push({
					url: 'xmlrpcclientview',
					prepend: {},
					style: {},
					items: {
						'id'         			: row.id,
						'ClientName' 			: row.clientName,
						'ClientApiId'			: row.clientApiId,
						'CallbackUrl'			: row.callbackUrl,
						'TriggerSentToSales'	: row.triggerSentToSales ? 'Yes' : 'No',
						'Created'				: row.created,
						'Archived'				: row.archived ? 'Yes' : 'No'
				}
				});
			}
			_w.xmlrpcclients.ti.hydrateParam('gridXmlRpcRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.xmlrpcclients.pageXmlRpcGrid;
			_w.xmlrpcclients.ti.hydrateParam('gridXmlRpcPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderXmlRpcGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.xmlrpcclients.loadXmlRpcGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
			win.document.write(response);
		}

	};

})();