;(function(){

	_App.ElementLibrary = function()
	{
		this.initialize();
	};

	_App.ElementLibrary.prototype =
	{

		initialize : function()
		{
			// Nothing to do.
		},

		Button : {
			html : function( meta )
			{
				if (null == meta)
				{
					return '';
				}
				if (meta.preset)
				{
					var disabledclass = undefined != meta.permission && false == meta.permission
						? 'disabled'
						: '';
					switch(meta.preset)
					{
					case 'GridExport':
						return '<button type="button" id="' + meta.id + '" class="btn hidden-phone" ' + disabledclass + '>'
								+ '<i class="icon-export"></i>'
								+ 'Export information'
								+ '</button>';
					case 'NewValuation':
						return '<button type="button" id="' + meta.id + '" class="btn btn-warning btn-new-valuation mobile-new-valuation" ' + disabledclass + '>'
								+ '<span class="btn-shine mobile-btn-shine"></span>'
								+ '<span class="btn-content">'
								+ '<i class="icon-new mobile-icon-new"></i>'
								+ 'New valuation'
								+ '</span></button>';
					case 'ValuationReport':
						return '<button type="button" id="' + meta.id + '" class="btn btn-primary btn-valuation-report" ' + disabledclass + '>'
								+ '<span class="btn-content">'
								+ 'Valuation Report'
								+ '</span></button> ';
					case 'NewStock':
						return '<button type="button" id="' + meta.id + '" class="btn btn-warning btn-new-valuation mobile-new-valuation" ' + disabledclass + '>'
								+ '<span class="btn-shine mobile-btn-shine"></span>'
								+ '<span class="btn-content">'
								+ '<i class="icon-new mobile-icon-new"></i>'
								+ 'New stock'
								+ '</span></button>';
                    case 'AuctionReport':
                        return '<button type="button" id="' + meta.id + '" class="btn btn-primary hidden-phone btn-margin-right-5" ' + disabledclass + '>'
                            + '<i class="icon-download-alt-2"></i>'
                            + ' Auction Report'
                            + '</button>';
                    case 'BulkImporter':
                        return '<button type="button" id="' + meta.id + '" class="btn btn-success hidden-phone btn-margin-right-5" ' + disabledclass + '>'
                            + '<i class="icon-folder-open-alt-2"></i>'
                            + ' Bulk Upload'
                            + '</button>';
					case 'SellVehicle':
						return '<button type="button" onClick="window.location.hash = \'/stockview?id=0\';" id="' + meta.id + '" class="btn btn-warning btn-new-valuation mobile-new-valuation" ' + disabledclass + '>'
								+ '<span class="btn-shine mobile-btn-shine"></span>'
								+ '<span class="btn-content">'
								+ '<i class="icon-new mobile-icon-new"></i>'
								+ 'Sell a Vehicle'
								+ '</span></button>';
					case 'Print':
						return '<button type="button" id="' + meta.id + '" class="btn" ' + disabledclass + '>'
								+ '<i class="icon-print printer"></i>'
								+ 'Print'
								+ '</button>';
					case 'PrintTC':
						return '<button type="button" id="' + meta.id + '" class="btn" ' + disabledclass + '>'
								+ '<i class="icon-print printer"></i>'
								+ 'Print with T&amp;C'
								+ '</button>';
					}
				}
				else
				{
					return '<button class="btn ' + meta.style + '">'
								+ (meta.icon ? '<i class="icon-' + meta.icon + '"></i>' : '')
								+ meta.title
								+ '</button>';
				}
			},
			bind : function( meta )
			{
				if (null == meta)
				{
					return;
				}
				if (meta.preset)
				{
					switch(meta.preset)
					{
					case 'NewValuation':
					case 'ValuationReport':
					case 'NewStock':
                    case 'AuctionReport':
                    case 'BulkImporter':
					case 'Print':
					case 'PrintTC':
					case 'GridExport':
						$("#" + meta.id).click(meta.handler);
						break;
					}
				}
				else
				{
					if (meta['bind'])
					{
						meta['bind'](meta);
					}
				}
			}
		},

		GridContextFilter : {
			html : function( meta )
			{

				if (null == meta)
				{
					return '<div class="width12p">&nbsp;</div>';
				}

				var style    = undefined != meta.style ? meta.style : 'span2';
				var divStyle = undefined != meta.divStyle ? meta.divStyle : '';
				var readonly = meta.readonly ? " readonly" : '';
				var prepend  = meta.prepend ? '<span class="add-on">' + meta.prepend + '</span>' : '';
				var append   = meta.append ? '<span class="add-on">' + meta.append + '</span>' : '';

				if (meta.actions)
				{
					return '<div class="' + style + ' btn-wrapper pull-right">'
							+ '<button type="button" id="' + meta.clearId + '" class="btn btn-clear-search">'
							+ '<i class="icon-remove-circle"></i>'
							+ 'Clear search'
							+ '</button>'
							+ '<button type="button" id="' + meta.searchId + '" class="mobile-search btn btn-success btn-submit-search">'
							+ '<i class="mobile-icon-search icon-search icon-white"></i>'
							+ 'Search'
							+ '</button>'
							+ '</div>';
				}
				else
				{
					if (meta.dataStoreId)
					{
						if (!meta.options)
						{
							meta.options = [];
						}
						if (!meta.selected)
						{
							meta.selected = '';
						}
						var selectMe = '';
						var html = '<div class="' + style + '">';
						html += '<p class="context-filter-label">';
						html += (meta.title ? meta.title : '&nbsp;');
						html += '</p>';
						html += '<div class="filter-input control-group' + divStyle + '">' + prepend
						html += '<select id="' + meta.id + '" name="' + meta.id + '" data-size="10" '
							  + 'class="sp selectpicker show-menu-arrow ' + (meta.context ? meta.context : '') + '">';
						for (var i = 0; i < meta.options.length; i++)
						{
							selectMe = (meta.options[i].value == meta.selected) ? ' selected' : '';
							html += '<option value="' + meta.options[i].value + '"' + selectMe + '>' + meta.options[i].label + '</option>';
						}
						html += '</select>';
						html += append + '</div>';
						html += '</div>';
						return html;
					}
					else
					{
						return '<div class="' + style + '">'
							+ '<p class="context-filter-label">'
							+ (meta.title ? meta.title : '&nbsp;')
							+ '</p>'
							+ '<div class="filter-input control-group' + divStyle + '">' + prepend
							+ '<input id="' + meta.id + '" type="text" placeholder="'
							+ meta.placeholder + '" class="' + meta.context + '"' + readonly + '>'
							+ append + '</div>'
							+ '</div>';
					}
				}
			},
			bind : function( meta )
			{
				if (null != meta && meta.dataStoreId)
				{
					App.DataStore.listen(
							meta.id, meta.dataStoreId,
							$.proxy(App.ElementLibrary.BuildSelectOptions, this, null, meta),
							'Recurring'
							);
				}
				if (meta && meta.actions)
				{
					$("#" + meta.clearId).click(meta.bindClear);
					$("#" + meta.searchId).click(meta.bindSearch);
				}
				else
				{
					if (null != meta && meta['bind'])
					{
						meta['bind'](meta);
					}
				}
			}
		},

		GridColumnHeader : {
			html : function( meta )
			{
				if (null == meta)
				{
					return '<th>&nbsp;</th>';
				}
				return '<th class="' + (meta.style ? meta.style : '') + '">'
						+ '<div class="table-heading-wrapper">'
						+ meta.title
						+ (meta.order
								? '<span id="' + meta.order.id + '" class="make-caret handy"></span>'
								: ''
						  )
						+ (meta.orderDesc
								? '<i id="' + meta.orderDesc.id + '" class="icon-circle-arrow-up icon-white handy pull-right"></i>'
								: ''
						  )
						+ (meta.orderAsc
								? '<i id="' + meta.orderAsc.id + '" class="icon-circle-arrow-down icon-white handy pull-right"></i>'
								: ''
						  )
						+ '</div>'
						+ '</th>';
			},
			bind : function( meta )
			{
				if (meta && meta.order)
				{
					$("#" + meta.order.id).click(meta.order.bind);
				}
				if (meta && meta.orderAsc)
				{
					$("#" + meta.orderAsc.id).click(meta.orderAsc.bind);
				}
				if (meta && meta.orderDesc)
				{
					$("#" + meta.orderDesc.id).click(meta.orderDesc.bind);
				}
				if (null != meta && meta['bind'])
				{
					meta['bind'](meta);
				}
			}
		},

		GridColumnFilter : {
			html : function( meta )
			{
				if (null == meta || !meta.id)
				{
					return '<td>'
					+ '<div class="filter-input">'
					+ '&nbsp;'
					+ '</div>'
					+ '</td>';
				}
				if (meta.dataStoreId)
				{
					if (!meta.options)
					{
						meta.options = [];
					}
					if (!meta.selected)
					{
						meta.selected = '';
					}
					var selectMe = '';
					var html = '<td>';
					html += '<div class="filter-input">';
					html += '<select id="' + meta.id + '" name="' + meta.id + '" data-size="10" '
						  + 'class="sp selectpicker show-menu-arrow ' + (meta.context ? meta.context : '') + '">';
					for (var i = 0; i < meta.options.length; i++)
					{
						selectMe = (meta.options[i].value == meta.selected) ? ' selected' : '';
						html += '<option value="' + meta.options[i].value + '"' + selectMe + '>' + meta.options[i].label + '</option>';
					}
					html += '</select>';
					html += '</div>';
					html += '</td>';
					return html;
				}
				else
				{
					return '<td>'
							+ '<div class="filter-input">'
							+ '<input type="text" id="' + meta.id + '" class="'
							+ (meta.context ? meta.context : '') + '" value="'
							+ (meta.value ? meta.value : '')
							+ '">'
							+ '</div>'
							+ '</td>';
				}
			},
			bind : function( meta )
			{
				if (null != meta && meta['bind'])
				{
					meta['bind'](meta);
				}
				if (null != meta && meta.dataStoreId)
				{
					App.DataStore.listen(
							meta.id, meta.dataStoreId,
							$.proxy(App.ElementLibrary.BuildSelectOptions, this, null, meta),
							'Recurring'
							);
				}
			}
		},

		GridDataRow : {
			html : function( meta )
			{

				if (null == meta)
				{
					return '<tr><td></td></tr>';
				}
				id = meta.items.id;
				delete meta.items.id;
				if (isNaN(id))
				{
					var ident = [];
					for (var field in id)
					{
						ident.push(field + '=' + id[field]);
					}
					var identifier = ident.join('&');
				}
				else
				{
					var identifier = 'id=' + id;
				}

				lineClass = meta.lineClass
					? meta.lineClass
					: '';
				var rowId = meta.rowId
					? 'id="row' + meta.rowId + '"'
					: '';
				var html = meta.url
					? '<tr ' + rowId + ' class="handy '+ lineClass +'" onClick="window.location=\'#/' + meta.url + '?' + identifier + '\';">'
					: '<tr ' + rowId + 'class="'+ lineClass +'">';
				if (!meta.style)
				{
					meta.style = {};
				}
				if (!meta.prepend)
				{
					meta.prepend = {};
				}
				if (!meta.append)
				{
					meta.append = {};
				}
				for (var item in meta.items)
				{
					html += '<td class="' + item + ' ' + (meta.style[item] ? meta.style[item] : '') + '">'
						+ (meta.prepend[item] ? meta.prepend[item] : '')
						+ (null != meta.items[item] ? meta.items[item] : '&nbsp;')
						+ (meta.append[item] ? meta.append[item] : '')
						+ '</td>';
				}
				html += '</tr>';
				return html;
			},
			bind : function( meta )
			{
				if (null != meta && meta['bind'])
				{
					meta['bind'](meta);
				}
				if (null != meta && meta.onClick && meta.rowId)
				{
					$('#row' + meta.rowId).click($.proxy(meta.onClick, this, meta));
				}
			}
		},

		GridPager : {
			html : function( meta )
			{
				if (null == meta)
				{
					return '&nbsp;';
				}
				var html = '<div class="pagination pull-right"><ul>';
				html += '<li><a data-page="1" class="' + meta.itemName + '"> &lt;&lt; </a></li>';
				var startPage = parseInt( meta.CurrentPage, 10 ) - 10;
				var endPage = parseInt( meta.CurrentPage, 10 ) + 10;

				if( startPage < 1 )
				{
					startPage = 1;
					endPage = 21 - startPage;
				}
				if( endPage > meta.TotalPages )
				{
					endPage = meta.TotalPages;
					startPage = endPage - 21;
				}
				if (startPage < 1)
				{
					startPage = 1;
				}
				if( endPage > meta.TotalPages )
				{
					endPage = meta.TotalPages;
				}

				for (var i = startPage; i <= endPage; i++)
				{
					html +=  (i == meta.CurrentPage)
						? '<li><span data-page="' + i + '" class="' + meta.itemName + ' active"><b><i>' + i + '</i></b></span></li>'
						: '<li><a data-page="' + i + '" class="' + meta.itemName + '">' + i + '</a></li>';
				}
				html += '<li><a data-page="' + meta.TotalPages + '" class="' + meta.itemName + '"> &gt;&gt; </a></li>';
				html += '</ul></div>';
				return html;
			},
			bind : function( meta )
			{
				if (meta && meta.bind)
				{
					$('.' + meta.itemName).click(function () {
						meta['bind']($(this).attr('data-page'));
					});
				}
			}
		},




		BuildSelectOptions : function ( tid, meta, dataId, options )
		{
			App.DataStore.setItem('BuildSelect:' + meta.id, true);
			var selected = $('#' + meta.id).val();
			if (!selected)
			{
				if (meta.value)
				{
					if (meta.multiple)
					{
						selected = [];
						for (var ii = 0; ii < meta.value.length; ii++)
						{
							selected.push(meta.value[ii]['id']);
						}
					}
					else
					{
						selected = meta.value;
					}
				}
				else
				{
					selected = '';
				}
			}
			else if (meta.multiple)
			{
				selected = null != selected
					? ('string' == typeof selected ? selected.split(',') : [selected])
					: [];
			}
			var html = '';
			if (meta.selectEmpty)
			{
				html += '<option value="">' + meta.selectEmpty + '</option>';
			}
			for (var i = 0; i < options.length; i++)
			{
				html += '<option value="' + options[i].value + '">' + options[i].label + '</option>';
			}
			$('#' + meta.id).html(html);
			$('#' + meta.id).selectpicker('refresh');
			$('#' + meta.id).selectpicker('val', selected);
			App.DataStore.removeItem('BuildSelect:' + meta.id);
		},


		BuildSelectOptions2 : function ( tid, meta, dataId, options )
		{
			var elemId = meta.filterId
				? meta.filterId
				: meta.id;
			App.DataStore.setItem('BuildSelect:' + elemId, true);
			var selected = $('#' + elemId).val();
			if (!selected)
			{
				if (meta.value)
				{
					if (meta.multiple)
					{
						selected = [];
						var selectMulti = {};
						for (var ii = 0; ii < meta.value.length; ii++)
						{
							selected.push(meta.value[ii].toString());
							selectMulti['x' + meta.value[ii]] = true;
						}
					}
					else
					{
						selected = meta.value;
					}
				}
				else
				{
					selected = '';
				}
			}
			else if (meta.multiple)
			{
				selected = [];
				var selectMulti = {};
				for (var ii = 0; ii < meta.value.length; ii++)
				{
					selected.push(meta.value[ii]['id'].toString());
					selectMulti['x' + meta.value[ii]['id']] = true;
				}
			}
			var opts = '';
			if (meta.selectEmpty)
			{
				opts += '<option value="">' + meta.selectEmpty + '</option>';
			}
			var doSelect = '';
			for (var i = 0; i < options.length; i++)
			{
				if (meta.multiple)
				{
					var val = options[i].value;
					doSelect = (selectMulti['x' + val])
						? 'selected'
						: '';
				}
				else
				{
					doSelect = (options[i].value == selected)
						? 'selected'
						: '';
				}
				opts += '<option value="' + options[i].value + '" ' + doSelect + '>' + options[i].label + '</option>';
			}
			$('#' + elemId).html(opts);
			$('#' + elemId).select2('updateResults', true);
			$('#' + elemId).select2('val', selected);
			App.DataStore.removeItem('BuildSelect:' + elemId);
		},




		BuildCheckGroupHtml : function ( meta, options )
		{
			var items = {};
			if (undefined != meta.data)
			{
				for (var i = 0; i < meta.data.length; i++)
				{
					items['i' + meta.data[i]] = true;
				}
			}

			var sectiontMax = Math.ceil(options.length / 2);
			var divClass = 'control-group column-right';
			if (meta.split && 4 == meta.split)
			{
				var sectiontMax = Math.ceil(options.length / 4);
				var divClass = 'span3';
			}

			var html = (meta.split && 4 == meta.split)
				? '<div class="row-fluid"><div class="span3">'
				: '<div class="control-group mobile-control-group column-left">';
			var r = 0;
			for (var i = 0; i < options.length; i++)
			{
				if (r == sectiontMax)
				{
					html += '</div>';
					html += '<div class="' + divClass + '">';
					r = 0;
				}
				var itemId = options[i].value;
				var label = options[i].label;
				var checked = items['i' + itemId]
					? ' checked'
					: '';
				html += '<label class="checkbox checkbox-line">';
				html += '<input type="checkbox" id="' + meta.itemName + itemId + 'Check" ';
				html += 'value=""' + checked + ' class="' + meta.itemName + '" data-id="' + itemId + '">';
				html += label;
				html += '</label>';
				r++;
			}
			html += '</div>';
			if ((meta.split && 4 == meta.split))
			{
				html += '</div>';
			}
			return html;
		},

		BuildCheckGroup : function ( tid, meta, dataId, options )
		{
			var elem = $('#' + meta.id);
			if (!elem)
			{
				return;
			}
			$('#' + meta.id).empty();
			var html = App.ElementLibrary.BuildCheckGroupHtml(meta, options);

			$('#' + tid + '_' + meta.id).html(html);
			for (var i = 0; i < options.length; i++)
			{
				App.Util.updateCheckboxStyle($('#' + meta.itemName + options[i].value + 'Check'));
			}
		},

		BuildAmountCheckGroupHtml : function ( meta, options )
		{
			var damages = {};
			if (undefined != meta.data)
			{
				for (var i = 0; i < meta.data.length; i++)
				{
					damages['d' + meta.data[i].damage] = meta.data[i].amount;
				}
			}

			var html = '';
			var disabled = meta.disabled
				? ' disabled'
				: '';
			for (var i = 0; i < options.length; i++)
			{
				var dmgId = options[i].value;
				var label = options[i].label;
				var amount = damages['d' + dmgId]
					? damages['d' + dmgId]
					: '0.00';
				var checked = '0.00' == amount
					? ''
					: ' checked';
				var disable = '0.00' == amount || meta.disabled
					? ' disabled'
					: '';
				html += '<div class="control-group mobile-control-group">';
				html += '<label class="checkbox checkbox-line">';
				html += '<input type="checkbox" id="damage' + dmgId + 'Check" ';
				html += 'value=""' + checked + ' data-target="damage' + dmgId + 'Amount" ' + disabled + '>';
				html += label;
				html += '</label>';
				html += '<div class="controls mobile-controls">';
				html += '<input class="rand-input damage-input" type="text" data-id="' + dmgId + '"';
				html += 'id="damage' + dmgId + 'Amount" name="damage' + dmgId + 'Amount" value="' + amount + '"' + disable + '>';
				html += '</div>';
				html += '</div>';
			}
			return html;
		},

		BuildAmountCheckGroup : function ( tid, meta, dataId, options )
		{
			var elem = $('#' + meta.id);
			if (!elem)
			{
				return;
			}
			$('#' + meta.id).empty();
			var html = App.ElementLibrary.BuildAmountCheckGroupHtml(meta, options);

			$('#' + tid + '_' + meta.id).html(html);
			for (var i = 0; i < options.length; i++)
			{
				var elem = $('#damage' + options[i].value + 'Check');
				App.Util.updateCheckboxStyle(elem);
				elem.change(function () {
					var checked = $(this).prop('checked');
					var amntElem = $('#' + $(this).attr('data-target'));
					amntElem.val('0.00');
					amntElem.prop('disabled', !checked);
					amntElem.trigger('change');
				});
			}
			$('.rand-input').change(function () {
				var total = 0.00;
				$.each($.find('.damage-input'), function(i, input) {
					total += parseFloat($(input).val());
				});
				$('#' + tid + '_damageTotal').html('R ' + total);
			});
			var total = 0.00;
			$.each($.find('.damage-input'), function(i, input) {
				total += parseFloat($(input).val());
			});
			$('#' + tid + '_damageTotal').html('R ' + total);
			App.DataStore.removeItem('BuildAmountCheck:' + meta.id);
		},

		Field : {
			html : function ( meta, value )
			{
				if (null == meta)
				{
					return '&nbsp;';
				}
				var disabled = undefined != meta.disabled && meta.disabled
					? ' disabled'
					: '';
				switch(meta.type)
				{
				case 'input':
					var max = meta.maxlength
						? ' maxlength="' + meta.maxlength + '"'
						: '';
					var placeholder = meta.placeholder
						? meta.placeholder
						: '';
					if ('rand-input' == meta.style)
					{
						placeholder = '0.00';
					}
					var html = '<label class="control-label mobile-control-label" ';
					html += 'for="' + meta.id + '">' + meta.title + ':</label>';
					html += '<div class="controls mobile-controls">';
					html += '<input class="information-input mobile-information-input ' + (meta.style ? meta.style : '') + '" ';
					html += 'placeholder="' + placeholder + '" type="text" id="' + meta.id + '" name="' + meta.id + '"' + max + disabled + '>';
					html += '</div>';
					return html;
					break;
				case 'date':
					var attr = meta.attrib
						? meta.attrib
						: '';
					var html = '<label class="control-label mobile-control-label" ';
					html += 'for="' + meta.id + '">' + meta.title + ':</label>';
					html += '<div class="controls mobile-controls">';
					html += '<input class="information-input mobile-information-input datepicker ' + (meta.style ? meta.style : '') + '" ';
					html += 'type="text" data-date-format="yyyy-mm-dd" ' + attr + ' id="' + meta.id + '" name="' + meta.id + '"' + disabled + '>';
					html += '</div>';
					return html;
					break;
				case 'mobile':
					var html = '<label class="control-label mobile-control-label" ';
					html += 'for="' + meta.id + '">' + meta.title + ':</label>';
					html += '<div class="input-prepend">';
					html += '<span class="add-on">+264</span>';
					html += '<input class="information-input mobile-information-input-short ' + (meta.style ? meta.style : '') + '" ';
					html += 'type="text" id="' + meta.id + '" name="' + meta.id + '"' + disabled + '>';
					html += '</div>';
					return html;
					break;
				case 'checkbox':
					var html = '<label class="checkbox checkbox-line">';
					html += '<input type="checkbox" id="' + meta.id + '" value=""' + disabled + '>';
					html += meta.title;
					html += '</label>';
					return html;
					break;

				case 'checkGroup':
					var options = App.DataStore.dataStore[meta.dataStoreId]
						? App.DataStore.dataStore[meta.dataStoreId]
						: {};
					var html = App.ElementLibrary.BuildCheckGroupHtml(meta, options);
					return html;
					break;
				case 'damageDetails':
					var options = App.DataStore.dataStore[meta.dataStoreId]
						? App.DataStore.dataStore[meta.dataStoreId]
						: {};
					var html = App.ElementLibrary.BuildAmountCheckGroupHtml(meta, options);
					return html;
					break;
				case 'amountCheck':
					var html = '<label class="checkbox checkbox-line">';
					html += '<input type="checkbox" id="' + meta.id + '" value=""' + disabled + '>';
					html += meta.title;
					html += '</label>';
					html += '<div class="controls mobile-controls">';
					html += '<input class="rand-input" type="text" id="' + meta.amountId + '" disabled>';
					html += '</div>';
					return html;
					break;
				case 'amount':
					var html = '<label class="control-label mobile-control-label">';
					html += meta.title;
					html += '</label>';
					html += '<div class="controls mobile-controls">';
					html += '<input class="wide-rand-input" type="text" id="' + meta.id + '">';
					html += '</div>';
					return html;
					break;
				case 'amountAuction':
					var html = '<label class="control-label mobile-control-label">';
					html += meta.title;
					html += '</label>';
					html += '<div class="controls mobile-controls">';
					html += '<input class="wide-rand-auction-input" type="text" id="' + meta.id + '">';
					html += '</div>';
					return html;
					break;
				case 'select2': //select2
					if (meta.dataStoreId)
					{
						if (meta.dataList)
						{
							App.DataStore.setData(meta.dataStoreId, meta.dataList);
						}
						else if (meta.dataQuery)
						{
							App.dataStoreId.loadSelectListData(
									meta.dataStoreId,
									meta.dataQuery.isStatic,
									meta.dataQuery.workspace,
									meta.dataQuery.task,
									meta.dataQuery.jobId,
									meta.dataQuery.data,
									meta.dataQuery.options,
									meta.dataQuery.callback
							);
						}
					}
					if (!meta.options)
					{
						meta.options = [];
					}
					if (!meta.value)
					{
						meta.value = !meta.multiple
							? ''
							: [];
					}
					var eid = meta.id;
					var attrib = '';
					var label = '';
					var labelStyle = '';
					var inputStyle = '';
					var inputWrapperStyle = '';
					var labelSpan = '';
					var inputSpan = '';
					if (meta.multiple)
					{
						attrib += ' multiple';
					}
					attrib += meta.title
						? ' data-placeholder="' + meta.title + '"'
						: ((meta.title && !meta.selectEmpty)
								? ' data-placeholder="' + meta.title + '"'
								: '');
					var options = '';
					if (meta.selectEmpty)
					{
						options += '<option value="">meta.selectEmpty</option>';
					}
					for (var i = 0; i < meta.options.length; i++)
					{
						options += '<option value="' + meta.options[i].value + '">' + meta.options[i].label + '</option>';

					}
					if (meta.title)
					{
						// the check here
						if (undefined != meta.options.query)
						{
							var html = '<label for="' + eid + '" class="' + labelSpan + ' control-label mobile-control-label' + labelStyle + '">' + meta.title + ':</label>'
								+ '<div class="' + inputSpan + ' ' + inputWrapperStyle + ' controls mobile-controls">'
								+ '<div id="' + eid + '" name="' + eid + '" class="selector2 show-menu-arrow ' + inputStyle + '"'
								+ ' ' + attrib + ' ' + disabled + '>'
								+ '</div>'
								+ '</div>';
						}
						else
						{
							var html = '<label for="' + eid + '" class="' + labelSpan + ' control-label mobile-control-label' + labelStyle + '">' + meta.title + ':</label>'
								+ '<div class="' + inputSpan + ' ' + inputWrapperStyle + ' controls mobile-controls">'
								+ '<select id="' + eid + '" name="' + eid + '" class="selector2 show-menu-arrow ' + inputStyle + '"'
								+ ' ' + attrib + ' ' + disabled +'>'
								+ ' ' + options + ' '
								+ '</select>'
								+ '</div>';
						}


					}
					else
					{
						if (undefined != meta.options.query)
						{
							var html = '<div class="' + inputSpan + ' ' + inputWrapperStyle + ' controls mobile-controls">'
								+ '<div id="' + eid + '" name="' + eid + '" class="selector2 show-menu-arrow' + inputStyle + '"'
								+ ' ' + attrib + ' ' + disabled + '>'
								+ '</div>'
								+ '</div>';
						}
						else
						{
							var html = '<div class="' + inputSpan + ' ' + inputWrapperStyle + ' controls mobile-controls">'
								+ '<select id="' + eid + '" name="' + eid +'" class="selector2 show-menu-arrow ' + inputStyle + '"'
								+ ' ' + attrib + ' ' + disabled + '>'
								+ ' ' + options + ' '
								+ '</select>'
								+ '</div>';
						}
					}
					return html;
					break;
				case 'select':
					if (!meta.options)
					{
						meta.options = [];
					}
					if (!meta.value)
					{
						meta.value = !meta.multiple
							? ''
							: [];
					}
					var multi = meta.multiple
						? ' multiple title="' + meta.title + '"'
						: ' title="' + meta.title + '"';
					var selectMe = '';
					var html = '';
					if (meta.title)
					{
						html += '<label class="control-label mobile-control-label" for="' + meta.id + '">' + meta.title + ':</label>';
					}
					html += '<select id="' + meta.id + '" name="' + meta.id + '" data-size="10" class="sp selectpicker show-menu-arrow"' + multi + disabled + '>';
					for (var i = 0; i < meta.options.length; i++)
					{
						if (meta.multiple)
						{
							selectMe = '';
							for (var sv = 0; sv < meta.value.length; sv++)
							{
								if (meta.value[sv]['id'] == meta.options[i].value)
								{
									selectMe = ' selected';
									break;
								}
							}
						}
						else
						{
							selectMe = (meta.options[i].value == meta.value) ? ' selected' : '';
						}
						selectMe = '';
						html += '<option value="' + meta.options[i].value + '"' + selectMe + '>' + meta.options[i].label + '</option>';
					}
					html += '</select>';
					return html;
					break;
				case 'textarea-small':
					var html = '<label class="control-label mobile-control-label" for="' + meta.id + '">' + meta.title + ':</label>';
					html += '<textarea id="' + meta.id + '" class="text-box-small" rows="3"' + disabled + ' maxlength="500"></textarea>';
					return html;
					break;
				case 'htmltext':
					//var html = '<label class="control-label mobile-control-label pad-top-none" for="' + meta.id + '">' + meta.title + ':</label><br/>';
					//html += '<textarea id="' + meta.id + '" class="span12" rows="12"' + disabled + '></textarea>';
					var html = '';
					html += '<div id="' + meta.id + '-toolbar" class="btn-toolbar" data-role="editor-toolbar" data-target="#' + meta.id + '">';
					html += '  <div class="btn-group">';
					html += '    <a class="btn dropdown-toggle" data-toggle="dropdown" title="" data-original-title="Font Size"><i class="icon-text-height"></i>&nbsp;<b class="caret"></b></a>';
					html += '      <ul class="dropdown-menu">';
					html += '      <li><a data-edit="fontSize 5"><font size="5">Huge</font></a></li>';
					html += '      <li><a data-edit="fontSize 3"><font size="3">Normal</font></a></li>';
					html += '      <li><a data-edit="fontSize 1"><font size="1">Small</font></a></li>';
					html += '      </ul>';
					html += '  </div>';
					html += '  <div class="btn-group">';
					html += '    <a class="btn" data-edit="bold" title="" data-original-title="Bold (Ctrl/Cmd+B)"><i class="icon-bold"></i></a>';
					html += '    <a class="btn" data-edit="italic" title="" data-original-title="Italic (Ctrl/Cmd+I)"><i class="icon-italic"></i></a>';
					html += '  </div>';
					html += '  <div class="btn-group">';
					html += '    <a class="btn" data-edit="outdent" title="" data-original-title="Reduce indent (Shift+Tab)"><i class="icon-indent-left"></i></a>';
					html += '    <a class="btn" data-edit="indent" title="" data-original-title="Indent (Tab)"><i class="icon-indent-right"></i></a>';
					html += '  </div>';
					html += '  <div class="btn-group">';
					html += '    <a class="btn btn-info" data-edit="justifyleft" title="" data-original-title="Align Left (Ctrl/Cmd+L)"><i class="icon-align-left"></i></a>';
					html += '    <a class="btn" data-edit="justifycenter" title="" data-original-title="Center (Ctrl/Cmd+E)"><i class="icon-align-center"></i></a>';
					html += '    <a class="btn" data-edit="justifyright" title="" data-original-title="Align Right (Ctrl/Cmd+R)"><i class="icon-align-right"></i></a>';
					html += '    <a class="btn" data-edit="justifyfull" title="" data-original-title="Justify (Ctrl/Cmd+J)"><i class="icon-align-justify"></i></a>';
					html += '  </div>';
					html += '</div>';
					html += '<div id="' + meta.id + '" contenteditable="true" class="wysiwyg-editor">';
					html += '';
					html += '</div>';
					return html;
					break;
				case 'textarea-styled':
					var style = meta.areaStyle
						? meta.areaStyle
						: 'textbox';
					var html = '<p class="' + meta.style + '">' + meta.title + ':</p>';
					html += '<textarea id="' + meta.id + '" class="' + style + '" rows="4"' + disabled + ' maxlength="500"></textarea>';
					return html;
					break;
				case 'image':
					var html = '';
					html += '<input id="btn_' + meta.id + '" class="hide" ';
					html += 'type="file" name="files[]" data-url="/workspace/image-upload">';
					html += '<input type="hidden" id="' + meta.id + '">';
					html += '<img id="img_' + meta.id + '" ';
					html += 'src="/imgs/' + meta.baseImage + '" ';
					html += 'class="img-polaroid motor-vichile-imgs handy">';
					return html;
					break;
				case 'bidMainImage':
					var html = '';
					html += '<img id="bidImgMain" src="/imgs/' + meta.baseImage + '"';
					html += 'data-zoom="" ';
					html += 'class="handy" width="100%" height="100%" />';
					return html;
					break;
				case 'bidimage':
					var html = '';
					html += '<a id="bidHref' + meta.id + '" data-image=""';
					html += 'data-zoom-image="" width="140px" height="140px">';
					html += '<img id="bidImg' + meta.id + '" src="/imgs/' + meta.baseImage + '" class="img-polaroid handy span12" width="140px" height="140px"/>'; // width="80%" height="80%"
					html += '</a>';

					return html;
					break;
				case 'attachment':
					var html = '';
					html += '<div class="span3"><input id="btn_' + meta.id + '" class="hide" ';
					html += 'type="file" name="files[]" data-url="/workspace/attachment-upload">';
					html += '<input type="hidden" id="' + meta.id + '">';
					html += '<img id="doc_' + meta.id + '" ';
					html += 'src="/imgs/upload.png" ';
					html += 'class="img-polaroid handy"></div>';
					html += '<div class="span7"><label for="btn_' + meta.id + '">' + meta.title + '</label></div>';
					return html;
					break;
				case 'document':
					var html = '';
					html += '<div class="span3"><input id="btn_' + meta.id + '" class="hide" ';
					html += 'type="file" name="files[]" data-url="/workspace/document-upload">';
					html += '<input type="hidden" id="' + meta.id + '">';
					html += '<img id="doc_' + meta.id + '" ';
					html += 'src="/imgs/upload.png" ';
					html += 'class="img-polaroid handy">';
					if (App.userData && 'test9@nirph.com' == App.userData.email)
					{
						html += '<img id="doc_rmv_' + meta.id + '" ';
						html += 'src="/imgs/x_img.jpg" ';
						html += 'class="img-polaroid doct-remove handy hide">';
					}
					html += '</div>';
					html += '<div class="span7"><label for="btn_' + meta.id + '">' + meta.title + '</label></div>';
					return html;
					break;
                case 'document_button':
                    var html = '';
                    html += '<div class="span6">';
                    html += '<img id="doc_' + meta.id + '"';
                    html += 'src="/imgs/upload.png" ';
                    html += 'class="img-polaroid handy">';
                    html += '<input id="btn_' + meta.id + '"';
                    html += 'type="file" data-url="/workspace/document-upload">';
                    html += '<input type="hidden" id="' + meta.id + '">';
                    if (App.userData && 'test9@nirph.com' == App.userData.email)
                    {
                        html += '<img id="doc_rmv_' + meta.id + '" ';
                        html += 'src="/imgs/x_img.jpg" ';
                        html += 'class="img-polaroid doct-remove handy hide">';
                    }
                    html += '</div>';
                    html += '<div class="span6 fileName" id="fileName"></div>';
                    //html += '<div class="span6"><input for="btn_' + meta.id + '" value="' + meta.title + '" data-url="/workspace/document-upload"></div>';

                    return html;
                    break;
				case 'collector':
					var html = '';
					html += '<div class="accordion" id="' + meta.id + '">';
					html += '</div>';
					return html;
					break;
				}
				return '';
			},
			setValue : function ( tid, meta, value )
			{
				if ('' == value)
				{
					return;
				}
				switch(meta.type)
				{
				case 'select':
					$('#' + meta.id).selectpicker('val', value);
					break;
				case 'select2': //select2
					$('#' + meta.id).select2('val', value);
					break;
				case 'checkbox':
					$('#' + meta.id).prop('checked', value);
					break;
				case 'amountCheck':
					$('#' + meta.id).prop('checked', value != '' ? true : false);
					$('#' + meta.amountId).val(value);
					break;
				case 'checkGroup':
				case 'damageDetails':
					//$('#' + meta.id).prop('checked', value != '' ? true : false);
					//$('#' + meta.amountId).val(value);
					break;
				case 'image':
					$('#img_' + meta.id).attr('src', '/img/bin/thumbnail/' + value.filename);
					$('#img_' + meta.id).attr('data-large', '/img/bin/' + value.filename);
					$('#' + meta.id).val(value.id);
					if ($('#img_' + meta.id).hasClass('error'))
					{
						$('#img_' + meta.id).removeClass('error');
						$('#img_' + meta.id).addClass('valid');
					}
					break;
				case 'bidMainImage':

					//console.log(value.filename);

					$('#bidImgMain').attr('src', '/img/bin/thumbnail/' + value.filename);
					$('#bidImgMain').attr('data-zoom-image', '/img/bin/' + value.filename);

					$("#bidImgMain").elevateZoom({
				 		zscrollZoom : true,
				 		gallery:'gal1',
				 		cursor: 'pointer',
				 		galleryActiveClass: 'active',
				 		imageCrossfade: true
				 	});

				 	$('#bidImgMain').css('max-width', '15.2%');
				 	$('#bidImgMain').css('min-width', '120px');
					//$('#bidImgMain').css('height', '20%');


					break;
				case 'bidimage':

						$('#tS1.jThumbnailScroller').css('min-width', '15.2%');
						$('#tS1.jThumbnailScroller').css('margin-top', '120px');
						$('#bidImgMain').css('max-width', '15.2%');
					 	$('#bidImgMain').css('min-width', '120px');

				 	$('#bidHref' + meta.id).css('width', '140px');
					$('#bidHref' + meta.id).css('height', '100px');

					$('#bidHref' + meta.id).attr('data-image', '/img/bin/thumbnail/' + value.filename);
					$('#bidHref' + meta.id).attr('data-zoom-image', '/img/bin/' + value.filename);
					$('#bidImg' + meta.id).attr('src', '/img/bin/thumbnail/' + value.filename);
					$('#bidImg' + meta.id).attr('data-large', '/img/bin/' + value.filename);
					$('#' + meta.id).val(value.id);
					break;
				case 'attachment':
					console.log(value);
					console.log('+++++++++++++++');
				case 'document':
					$('#doc_' + meta.id).attr('src', '/imgs/uploaded.png');
					if (App.userData && 'test9@nirph.com' == App.userData.email)
					{
						$('#doc_rmv_' + meta.id).show();
					}
					$('#doc_' + meta.id).attr('data-download', '/documents/' + value.filename);
					$('#' + meta.id).val(value.id);


				break;
                case 'document_button':
                    $('#doc_' + meta.id).attr('src', '/imgs/uploaded.png');
                    if (App.userData && 'test9@nirph.com' == App.userData.email)
                    {
                        $('#doc_rmv_' + meta.id).show();
                    }
                    $('#doc_' + meta.id).append('bla');
                    $('#doc_' + meta.id).attr('data-download', '/documents/' + value.filename);
                    $('#' + meta.id).val(value.id);


                    break;
				case 'mobile':
					if ('string' == typeof value && '0' == value.substring(0,1))
					{
						value = value.substring(1);
					}
					if ('string' == typeof value && '264' == value.substring(0,3))
					{
						value = value.substring(3);
					}
					if ('string' == typeof value && '+264' == value.substring(0,4))
					{
						value = value.substring(4);
					}
					$('#' + meta.id).val(value);
					break;
				case 'collector':
					break;
				case 'htmltext':
					$('#' + meta.id).html(value);
					break;
				default:
					$('#' + meta.id).val(value);
					break;
				}
			},
			harvest : function ( tid, meta )
			{
				if (null == meta)
				{
					return null;
				}
				switch(meta.type)
				{
				case 'collector':
					return null;
					break;
				case 'select':
					return $('#' + meta.id).val();
					break;
				case 'select2': //select2
					return $('#' + meta.id).select2('val');
					break;
				case 'checkGroup':
					var items = [];
					$.each($.find('.' + meta.itemName), function(i, input) {
						if ( $(input).prop('checked') )
						{
							items.push({
								'id': $(input).attr('data-id')
							});
						}
					});
					return items;
					break;
				case 'damageDetails':
					var damages = [];
					$.each($.find('.damage-input'), function(i, input) {
						var amount = $(input).val();
						amount = '' != amount
							? parseFloat(amount)
							: 0.00;
						if (0.00 != amount)
						{
							damages.push({
								'id': $(input).attr('data-id'),
								'amount': amount
							});
						}
					});
					return damages;
					break;
				case 'checkbox':
					return $('#' + meta.id).prop('checked');
					break;
				case 'mobile':
					value =  $('#' + meta.id).val();
					if (value && '0' == value.substring(0,1))
					{
						value = value.substring(1);
					}
					if (value && '+264' == value.substring(0,3))
					{
						value = value.substring(3);
					}
					return '+264' + value;
					break;
				case 'htmltext':
					return $('#' + meta.id).html();
					break;
				default:
					return $('#' + meta.id).val();
					break;
				}
			},
			bind : function ( tid, meta )
			{
				if (meta.mask)
				{
					$('#' + meta.id).mask(meta.mask);
					$('#' + meta.id).focus(function () {
						$('#' + meta.id).setCursorPosition(0);
					});
				}
				if ('select2' == meta.type) //select2
				{
					var defaults = {
							allowClear: true,
							closeOnSelect: false,
							width: "parent",
							placeholder: meta.title
								? meta.title
								: ((meta.label && !meta.selectEmpty)
									? meta.label
									: 'Select')
					};
					var options = meta.options
						? $.extend(true, {}, defaults, meta.options)
						: defaults;
					$('#' + meta.id).select2(options);
					$('#' + meta.id).val = function(value) {
						if (undefined == value)
						{
							return $(this).select2('val');
						}
						$(this).select2('val', value);
					};
				}
				if ('htmltext' == meta.type)
				{
					$('#' + meta.id).wysiwyg();

//					if (CKEDITOR && CKEDITOR.instances[meta.id])
//					{
//						/*try {*/ CKEDITOR.instances[meta.id].destroy(true); /*} catch (e) {}*/
//						//CKEDITOR.replace(meta.id);
//						$('#cke_content').remove();
//						console.log('......................');
//					}
//					//else
//					//{
//						//setTimeout(function () {
//							$('#' + meta.id).ckeditor({
//								toolbar : 'Basic',
//								language : 'en',
//								uiColor : '#F9F9F9',
//								resize_dir: 'vertical',
//								toolbarCanCollapse: true,
//								pasteFromWordRemoveFontStyles: true,
//								pasteFromWordRemoveStyles: true,
//								pasteFromWordPromptCleanup:true,
//								scayt_autoStartup:true,
//								scayt_sLang:'nl_NL',
//								width:'95%',
//								toolbar_Basic : [
//									{ name: 'document', items : [ 'Source'] },
//									{ name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat' ] },
//									{ name: 'clipboard', items : [ 'Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo' ] },
//									{ name: 'editing', items : [ 'Find','Replace','-','SelectAll','-','SpellChecker', 'Scayt' ] },
//									{ name: 'tools', items : [ 'Maximize', 'ShowBlocks' ] }
//								]
//							});
//						//}, 500);
//					//}
				}
				if ('document_button' == meta.type || 'document' == meta.type || 'attachment' == meta.type)
				{
					if (!meta.view)
					{
						if (App.userData && 'test9@nirph.com' == App.userData.email)
						{
							$('#doc_rmv_' + meta.id).click(function(metaId)
							{
								_w.systemdealerview.docFieldRemoveId = $(this).attr('id');
								_w.systemdealerview.docFieldRemove = $(this).attr('id').replace('doc_rmv_', '');
								App.API.getTask(
							              'removeDocument:' + _w.systemdealerview.itemId,
							              'Company', 'Company.RemoveDocument',
							              _w.systemdealerview.itemId,
							              {'id': _w.systemdealerview.itemId},
							              $.proxy(function()
							              {
							            	  var data = {
							            			  Company: {}
							            	  };
							            	  data.Company[_w.systemdealerview.docFieldRemove] = true;
							            	  App.API.execTask(
									                  'removeDocument:' + _w.systemdealerview.itemId, data, {},
									                  function () {
									                	  $('#' + _w.systemdealerview.docFieldRemoveId).remove();
									                  }, _w.taskExecError
								                  );
							              }, this),
							              _w.taskContractError
						              );
							});
						}

						$('#doc_' + meta.id).click(function()
						{
							if (undefined != $(this).attr('data-download'))
							{
								App.Ajax.DOWNLOAD({
									url: $(this).attr('data-download')
								});
							}
							else
							{
								$('#btn_' + meta.id).click();
							}
						});
						$('#btn_' + meta.id).fileupload({
						      dataType: 'json',
					    	  fail: function (e, data) {
								  alert('Could not upload document.');
						      },
						      done: function (e, data) {
						          $.each(data.result, function (i, file) {
						        	  if (file.error)
						        	  {
						        		  alert(file.error);
						        		  return;
						        	  }
                                      $('#fileName').html(data.files[0].name);
						              $('#' + meta.id).val(file.id);
						              $('#doc_' + meta.id).attr('src', '/imgs/uploaded.png');
						              $('#doc_' + meta.id).attr('data-download', '/documents/' + file.name);
						          });
						      }
					  	});
					}
					else
					{
						$('#doc_' + meta.id).click(function()
						{
							App.Ajax.DOWNLOAD({
								direct: true,
								url: $(this).attr('data-download')
							});
						});
					}
				}
				if ('image' == meta.type)
				{
					if (!meta.view)
					{
						$('#img_' + meta.id).click(function() {

							$('#btn_' + meta.id).click();
						});
						$('#btn_' + meta.id).fileupload({
						      dataType: 'json',
					    	  fail: function (e, data) {
								  alert('Could not upload image.');
						      },
						      done: function (e, data) {
						          $.each(data.result, function (i, file) {
						        	  if (file.error)
						        	  {
						        		  alert(file.error);
						        		  return;
						        	  }
						              $('#' + meta.id).val(file.id);
						              $('#img_' + meta.id).attr('src', '/img/bin/' + file.name);
						              if ($('#img_' + meta.id).hasClass('error'))
						              {
											$('#img_' + meta.id).removeClass('error');
											$('#img_' + meta.id).addClass('valid');
						              }
						          });
						      }
					  	});
					}
					else
					{
						$('#img_' + meta.id).click(function()
						{
							var _src = $('#img_' + meta.id).attr('data-large');
							if(undefined == _src || '' == _src)
							{
								return;
							}
							$('#imgLarge').attr('src', _src);
							$('#sectionMain').hide();
							$('#sectionImage').show();
						});
					}
				}
				if ('bidimage' == meta.type)
				{
					$('#bidImg' + meta.id).click(function()
					{
						var _src = $('#bidImg' + meta.id).attr('data-large');
						if(undefined == _src || '' == _src)
						{
							return;
						}
						$('#bidImgMain').attr('src', $('#bidImg' + meta.id).attr('src'));
						$('#bidImgMain').attr('data-zoom-image', _src);
					});

				}
				if ('bidMainImage' == meta.type)
				{
					// .....
				}
				if (meta.dataStoreId)
				{
					switch (meta.type)
					{
					case 'select':
						App.DataStore.listen(
								meta.id, meta.dataStoreId,
								$.proxy(App.ElementLibrary.BuildSelectOptions, this, tid, meta),
								'Recurring'
								);
						break;
					case 'select2': //select2
						App.DataStore.listen(
								meta.id, meta.dataStoreId,
								$.proxy(App.ElementLibrary.BuildSelectOptions2, this, tid, meta),
								'Recurring'
						);
						break;
					case 'checkGroup':
						App.DataStore.listen(
								meta.id, meta.dataStoreId,
								$.proxy(App.ElementLibrary.BuildCheckGroup, this, tid, meta),
								'Recurring'
								);
						break;
					case 'damageDetails':
						App.DataStore.listen(
								meta.id, meta.dataStoreId,
								$.proxy(App.ElementLibrary.BuildAmountCheckGroup, this, tid, meta),
								'Recurring'
								);
						break;
					}
				}
				if ('date' == meta.type)
				{
					var opt = meta.dtopt ? meta.dtopt : {};
					$('#' + meta.id).datepicker(opt);
				}
				if ('select' == meta.type || 'select2' == meta.type)
				{
					$('#' + meta.id).change(function() {
						if (!App.DataStore.getItem('BuildSelect:' + meta.id, false))
						{
							try
							{
								$(this).valid();
							}
							catch (err)
							{
								// no worries
							}
						}
					});
				}
				if (meta.onChange)
				{
					$('#' + meta.id).change(meta.onChange);
				}
				if (meta.onFocus)
				{
					$('#' + meta.id).on('focus', meta.onFocus);
				}
				if (meta.onBlur)
				{
					$('#' + meta.id).on('blur', meta.onBlur);
				}
				if (meta['bind'])
				{
					meta['bind'](meta);
				}
				if ('checkbox' == meta.type || 'amountCheck' == meta.type)
				{
					App.Util.updateCheckboxStyle( $('#' + meta.id) );
				}
			}
		}


	};
})();
