;(function(){

	window._w.questionview = {

		auctionId : null,
		itemId    : null,
		itemData  : null,
		formMeta  : null,
		ti        : null,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.questionview.ti = _t[template];
			_w.questionview.itemData = null;

			_w.questionview.setQuestionViewFormMeta();
			_w.questionview.ti.hydrate(_w.questionview.formMeta);

			// Retrieve initial view data.
			_w.questionview.itemId    = App.Util.getUrlParam('id');
			_w.questionview.auctionId = App.Util.getUrlParam('auctionId');
			App.API.getTask(
				'viewQuestion:' + _w.questionview.itemId, 'Auction', 'Question.View', _w.questionview.auctionId,
				{'id':_w.questionview.itemId}, _w.questionview._onQuestionViewDataReceived, _w.taskContractError
			);
			App.API.getTask(
				'createQuestion:' + _w.questionview.itemId, 'Auction', 'Question.Create', _w.questionview.auctionId,
				{}, function() {}, _w.taskContractError
			);
		},

		onViewPublished : function( template, event, eventData )
		{
			if (null != _w.questionview.itemData)
			{
				_w.questionview._onDataAndTemplate();
			}
		},

		setQuestionViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.questionview.formMeta = {
				'vehicle' : {
					title : 'Vehicle',
					value : data.auction
						? data.auction.stock.type.model.make.name
							+ ', ' + data.auction.stock.type.model.name
							+ ', ' + data.auction.stock.type.name
							+ ' (' + data.auction.stock.vehicleYear.name + ')'
						: ''
				},
				'created' : {
					title : 'Created',
					value : data.created ? ((data.created).split(' '))[0] : ''
				},
				'company' : {
					title : 'Company',
					value : data.company ? data.company.name : ''
				},
				'user' : {
					title : 'User',
					value : data.profile ? data.profile.firstName + ' ' + data.profile.familyName : ''
				},
				'question' : {
					title : 'Question',
					value : data.question ? data.question : ''
				},
				'reply' : {
					title : 'Reply',
					value : data.reply ? data.reply.reply : ''
				}
			};
		},

		_onDataAndTemplate : function() {
			_w.questionview._setupValidation();
		},

		_onQuestionViewDataReceived : function( response )
		{
			_w.questionview.itemId = response.Data.id;
			_w.questionview.itemData = response.Data;
			_w.questionview.setQuestionViewFormMeta(response.Data);
			_w.questionview.ti.hydrate(_w.questionview.formMeta);
			if (_w.questionview.ti.published)
			{
				_w.questionview._onDataAndTemplate();
			}
		},

		_setupValidation : function ()
		{
			$('#frmQuestionView').validate({
				submitHandler: function( form ) {
					if ('' == $('#question').val())
					{
						alert('Please specify a question.');
						return;
					}
					$('#btnUpdate').prop('disabled', true);
					var data = _w.questionview._prepQuestionUpdateData();
					App.API.execTask(
							'createQuestion:' + _w.questionview.itemId, data, {},
							_w.questionview._onQuestionUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
			if (!_w.questionview.itemData.question || !_w.questionview.itemData.question.id)
			{
				$('#btnUpdate').show();
			}
		},

		_prepQuestionUpdateData : function()
		{
			var data = {
					Question : {
						question : _w.questionview.itemId,
						question    : $('#question').val()
					}
			};
			return data;
		},

		_onQuestionUpdated : function( response )
		{
			window.location.hash = '/settings';
		}

	};

})();